##
##  neo4j-graphql.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         neo4j-graphql
Summary:      Neo4J Plugin for GraphQL
URL:          https://github.com/neo4j-graphql/neo4j-graphql
Vendor:       Neo4J-GraphQL Initiative
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Database
License:      Apache
Version:      3.5.21.5
Release:      20200909

#   list of sources
Source0:      https://github.com/neo4j-graphql/neo4j-graphql/releases/download/%{version}/neo4j-graphql-%{version}.jar

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101
PreReq:       OpenPKG, openpkg >= 20160101, neo4j

%description
    This is a GraphQL-Endpoint extension for the Neo4j graph database.
    Based on your GraphQL schema, it translates GraphQL Queries and
    Mutations into Cypher statements and executes them on Neo4j. It
    offers both an HTTP API, as well as, Neo4j Cypher Procedures to
    execute and manage your GraphQL API.

%track
    prog neo4j-graphql = {
        version   = %{version}
        url       = https://github.com/neo4j-graphql/neo4j-graphql/releases
        regex     = neo4j-graphql-(__VER__)\.jar
    }

%prep
    %setup -q -T -c

%build

%install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/lib/neo4j/plugins
    %{l_shtool} install -c -m 644 \
        %{SOURCE neo4j-graphql-%{version}.jar} \
        $RPM_BUILD_ROOT%{l_prefix}/lib/neo4j/plugins/neo4j-graphql.jar
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

%post
    if [ ".$1" = .1 ]; then
        #   add hook to PHP configuration
        neo4jconf="$RPM_INSTALL_PREFIX/etc/neo4j/neo4j.conf"
        if [ -f $neo4jconf ]; then
            ( echo "dbms.unmanaged_extension_classes=org.neo4j.graphql=/graphql" ) | \
            $RPM_INSTALL_PREFIX/lib/openpkg/rpmtool config \
                -a -i "$RPM_INSTALL_PREFIX:neo4j-graphql" -p "#" $neo4jconf
        fi
    fi

%postun
    if [ ".$1" = .0 ]; then
        #   remove hook from PHP configuration
        neo4jconf="$RPM_INSTALL_PREFIX/etc/neo4j/neo4j.conf"
        if [ -f $neo4jconf ]; then
            $RPM_INSTALL_PREFIX/lib/openpkg/rpmtool config \
                -r -i "$RPM_INSTALL_PREFIX:neo4j-graphql" -p "#" $neo4jconf
        fi
    fi

